//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "dlarbiter.h"

#include <simulation.h>
#include <algorithm> // for_each

REGISTER_ELEMENT(DeadlineArbiter, "Deadline");

DeadlineArbiter::DeadlineArbiter(const DOMElement* scope): Arbiter(scope)
{
	lfuList = new std::priority_queue <Wire *, std::vector<Wire *> , CompareProperty>;
}


DeadlineArbiter::~DeadlineArbiter()
{
}


bool DeadlineArbiter::init(const DOMElement* scope)
{
	return true;
}

const void DeadlineArbiter::accept(const std::vector< Wire * >& accepted_list)
{
}

void DeadlineArbiter::schedule(std::vector< Wire * > ins)
{
	if (!lfuList->empty()) {
		std::cerr << "WARNING (NOP) : DeadlineArbiter::schedule : my internal list of schedule objects was not empty." << std::endl;
		forget();
	}

	// put matching in prio_queue
	for (std::vector<Wire*>::iterator it = ins.begin(); it!=ins.end(); it++)
		lfuList->push((*it));

	
}

inline Wire* DeadlineArbiter::pop() {
	if (lfuList->empty())
		return NULL;

	Wire* out = lfuList->top();
	lfuList->pop();
	return out;
}

inline Wire* DeadlineArbiter::front() const
{
	if (lfuList->empty())
		return NULL;

	return lfuList->top();
}

inline const void DeadlineArbiter::forget() {
	delete lfuList;
	lfuList = new std::priority_queue <Wire *, std::vector<Wire *> , CompareProperty>;
}
