//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "globalroundrobinarbiter.h"
#include <simulation.h>

REGISTER_ELEMENT(GlobalRoundRobinArbiter, "RoundRobinGlobal")

GlobalRoundRobinArbiter::GlobalRoundRobinArbiter(const DOMElement* scope)
 : Arbiter(scope)
{
        SchedVar0 =0;
        SchedVar1 =0;
}


GlobalRoundRobinArbiter::~GlobalRoundRobinArbiter()
{
}


bool GlobalRoundRobinArbiter::init(const DOMElement* scope)
{
	return true;

}

void GlobalRoundRobinArbiter::schedule(std::vector< Wire * > ins)
{
	if (!Inputs()) {
		std::cerr << "ERROR (FATAL) : GlobalRoundRobinArbiter::schedule : Inputs missing" << std::endl;
		exit(1);
	}
        
	// ring reset
        if (SchedVar0 != Tick()) {
                SchedVar0 = Tick();
                SchedVar1 = Tick()%Inputs()->size();
        }

        // choose
        for (unsigned int i = 0; i < Inputs()->size(); i++) {
                // dann brauchen wir auch nicht ewig irgendwelche Werte zu suchen
                unsigned int trigger = SchedVar1 + i;
                // wenn wir beim letzten angekommen sind, von vorn den Rest
                if (trigger >= Inputs()->size() )
                        trigger = trigger-Inputs()->size();

                std::vector<Wire*>::const_iterator iter;
                iter = find (ins.begin(), ins.end(), (*Inputs())[trigger]);
                if (iter != ins.end())
                        scheduleList.push_back((*iter));
        }

        /*if (S.priorityused)
                scheduleList.sort();*/
}

inline Wire* GlobalRoundRobinArbiter::pop() {
	if (scheduleList.empty())
		return NULL;

	Wire* out = scheduleList.front();
	scheduleList.pop_front();
	return out;
	
}

inline Wire* GlobalRoundRobinArbiter::front() const
{
	if (scheduleList.empty())
		return NULL;

	return scheduleList.front();
}

inline const void GlobalRoundRobinArbiter::forget() {
	scheduleList.clear();
}
