//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <opfarbiter.h>

#include <algorithm> // for_each

REGISTER_ELEMENT(OPFArbiter, "OldestPacketFirst")

OPFArbiter::OPFArbiter(const DOMElement* scope): Arbiter(scope)
{
	opfList = new std::priority_queue <Wire *, std::vector<Wire *> , CompareProperty>;
}


OPFArbiter::~OPFArbiter()
{
}


bool OPFArbiter::init(const DOMElement* scope)
{
	return true;
}

const void OPFArbiter::accept(const std::vector< Wire * >& accepted_list)
{
}

void OPFArbiter::schedule(std::vector< Wire * > ins)
{
	if (!opfList->empty()) {
		std::cerr << "WARNING (NOP) : OPFArbiter::schedule : my internal list of schedule objects was not empty." << std::endl;
		forget();
	}

	// put matching in prio_queue
	for (std::vector<Wire*>::iterator it = ins.begin(); it!=ins.end(); it++) {
		opfList->push((*it));
	}
}

inline Wire* OPFArbiter::pop() {
	if (opfList->empty())
		return NULL;

	Wire* out = opfList->top();
	opfList->pop();
	return out;
}

inline Wire* OPFArbiter::front() const 
{
	if (opfList->empty())
		return NULL;

	return opfList->top();
}

inline const void OPFArbiter::forget() {
	delete opfList;
	opfList = new std::priority_queue <Wire *, std::vector<Wire *> , CompareProperty>;
}
