#include <randomarbiter.h>
#include <simulation.h>
#include <utility/random.h>

REGISTER_ELEMENT(RandomArbiter, "Random");

RandomArbiter::RandomArbiter(const DOMElement* scope)
 : Arbiter(scope)
{
}

RandomArbiter::~RandomArbiter()
{
}

bool RandomArbiter::init(const DOMElement* scope)
{
	return true;
}

void RandomArbiter::schedule(std::vector<Wire*> ins)
{
	if (!scheduleList.empty()) {
		std::cerr << "WARNING (NOP) : RandomArbiter::schedule : my internal list of schedule objects was not empty." << std::endl;
		forget();
	}

        RandomKofN    sack (ins.size());
        while(!sack.Empty())
                scheduleList.push_back(ins[sack.Choose()-1]);

        /*if (S.priorityused)
                scheduleList.sort();*/
}

inline Wire* RandomArbiter::pop() {
	if (scheduleList.empty())
		return NULL;
		
	Wire* out = scheduleList.front();
	scheduleList.pop_front();
	return out;	
}

inline Wire* RandomArbiter::front() const 
{
	if (scheduleList.empty())
		return NULL;
		
	return scheduleList.front();	
}

inline const void RandomArbiter::forget() {
	scheduleList.clear();
}
