#include <sequencer.h>
#include <environment.h>
#include <macros.h>

#include <utility/timekeeper.h>

#include <iostream>

int main(int argc, char **argv)
{
	Timekeeper tk_exec, tk_sim;
	
	Environment::Setup("CINSimEnv", argc, argv);

	// Simulationssequenz laden
	Sequencer::Load();
		
	std::cout << "XML-File parsed, starting simulation...\n";
        
	tk_sim.start();
	
	// Simulationssequenz starten
	Sequencer::Start();
	
	if(Env()->isSet(_SHOW_TIME_))
	{
		std::cout << "Programm execution took " << tk_exec.secs() 
			<< "s, simulation " << tk_sim.secs() << "s"
			<< std::endl;
	}
	
	Environment::Halt();
}
