#include <cinsimanalysis.h>
#include <variable.h>

#include <iostream>
#include <cassert>

REGISTER_ELEMENT(CINSimAnalysis,"CINSimAnalysis")


CINSimAnalysis::~CINSimAnalysis()
{
	if(_variables)
	{
		for(unsigned int i=0; i<_count; i++)
		{
			delete _variables[i];
		}

		delete [] _variables;
	}
}


bool CINSimAnalysis::declareVariables(const VariableInfo* infolist, unsigned int count)
{
	if(_variables)
	{
		for(unsigned int i=0; i<_count; i++)
		{
			delete _variables[i];
		}

		delete [] _variables;
	}
	
	_count = count;
	_variables = new Variable*[_count];
	
	for(unsigned int i=0; i<_count; i++)
	{
		_variables[i] = new Variable(infolist[i]);
	}
	
	return true;
}


bool CINSimAnalysis::advanceVariable(unsigned int var, double value, Result& result)
{
	bool update = false;
	
	if(_variables[var-1]->state() != Variable::FINISHED)
		update = _variables[var-1]->advance(value, result);
	
	return update;
}

void CINSimAnalysis::finishVariable(unsigned int variable)
{
	if(_variables[variable-1]->state() != Variable::FINISHED)
	{
		_variables[variable-1]->markFinished();
	}
}
