#ifndef PLUGINMANAGER_H
#define PLUGINMANAGER_H

#include <config.h>
#include <map>
#include <vector>
#include <macros.h>
#include <string.h>
#include <stdlib.h>

class PluginManager
{
public:

        PluginManager();
        ~PluginManager();

        struct plugin_info
        {
                void *handle;
                std::string filename;          // this is the filename of the plugin.
        };



        /*! Scan the plugins directory for plugins.
                 */
        std::vector<std::string> scanForPlugins(const std::string& directory = PLUGINDIR);

        /*! Get the plugin-map */
        const std::map<std::string, plugin_info> & getPluginMap()
        {
                return plugin_map;
        }

        void print();
private:

        std::string plugindir;
        // List of plugin that have been loaded
        std::vector<std::string> plugins;

        /**   plugin, plugin struct */
        std::map<std::string, plugin_info> plugin_map;

};
#endif
