#include <flit.h>
#include <packet.h>
#include <macros.h>

#include <iostream>
#include <sstream>
#include <cassert>

Flit::Flit(Packet* o, unsigned int i, unsigned int m)
{
	owner = o;
	offset = i;
	maxoffset = m;
	
	location.where=NULL;
	location.since=-1;
}
	
void Flit::setOwner(Packet* packet) 
{
	owner = packet; 

	// Annahme: Korrekte Reihenfolge (Flit 0, Flit1, ..) beim Klonen 
	// im RegisterContainer und aktuelles Flit unbearbeitet
	assert(owner->ownedflits==offset);
	
	owner->ownedflits++;
}

void Flit::buffered(Buffer* where, signed int since)
{
	location.where=where;
	location.since=since;
}

unsigned int Flit::neededSpace() const
{
	if(head())
		return owner->size();

	return 1;
}

std::string Flit::toString() const
{
	std::stringstream str;

	str << "Flit " << offset << " of " << owner->toString();

	return str.str();
}

