#include <node.h>

#include <utility/valuestring.h>


std::vector<Node*> Node::nextNodes(Node::Filter* nf) const
{
	std::vector<Node*> tmp;

	for(unsigned int i=0; i<_out.size(); i++)
	{
		Node* next = _out[i]->To();
		
		if(!nf || nf->valid(next))
			tmp.push_back(next);
		else
		{
			const std::vector<Node*>& tmp2 = next->nextNodes(nf);
			tmp.insert(tmp.end(),tmp2.begin(),tmp2.end());
		}
	}
	return tmp;
}


std::vector<Node*> Node::prevNodes(Node::Filter* nf) const
{
	std::vector<Node*> tmp;

	for(unsigned int i=0; i<_in.size(); i++)
	{
		Node* prev = _in[i]->From();
		
		if(!nf || nf->valid(prev))
			tmp.push_back(prev);
		else
		{
			const std::vector<Node*>& tmp2 = prev->prevNodes(nf);
			tmp.insert(tmp.end(),tmp2.begin(),tmp2.end());
		}
	}
	return tmp;
}


bool Node::setCoordinates(const char* coords)
{
	position.clear();

	char delims[] = ",()";
	char* buffer = strcpy(new char[strlen(coords)+1], coords);
	char* number = NULL;
	number = strtok(buffer, delims);
	while(number) 
	{
		// neuer Eintrag
		position.push_back((int)ValueString(number));

		number = strtok(NULL, delims);
	}

	assert(position.size() == 2);

	delete [] buffer;
	
	return true;
}
