#include <utility/xmlattribute.h>
#include <environment.h>
#include <macros.h>

#include <cassert>

XMLAttribute::XMLAttribute(const DOMAttr* attr) : ValueString(), attribute(attr)
{
	if(!attribute)
		_ERROR("No attribute node specified!");
	
	// Attributwert
	std::string tmp = XMLString::transcode(attribute->getValue());
			
	// Test auf CINSim-Variable
	if (Env()->isSet(tmp))
		// CINSim-Variable durch Wert ersetzen
		tmp = (std::string)Env()->getValue(tmp);

	setString(tmp);
}

const char* XMLAttribute::name() const
{
	assert(attribute);
	
	return XMLString::transcode(attribute->getName());
}
