#include <utility/xmlelement.h>
#include <utility/xmlhelper.h>

#include <assert.h>

XMLElement::XMLElement(const DOMElement* scope) : scope(scope)
{}

XMLElement::~XMLElement()
{}

XMLAttribute XMLElement::getAttribute(const char* name, const DOMElement* scope) const
{
	// Attribut aus aktuellem Scope
	const DOMElement* element = this->scope;
	
	// Optional: Abweichender Scope
	if (scope)
		element = scope;
	
	return parseAttribute(element,name);
}

const DOMElement* XMLElement::getParent(const DOMElement* scope) const
{
	// Attribut aus aktuellem Scope
	const DOMElement* element = this->scope;

	// Optional: Abweichender Scope
	if (scope)
		element = scope;

	return (DOMElement*)element->getParentNode();
}
