#include <wire.h>
#include <registercontainer.h>

#include <cassert>

REGISTER_ELEMENT(Wire, "route")

Wire::Wire(unsigned int iindex, unsigned int oindex) 
{
	_reg = NULL;
	_from = NULL; 
	_to = NULL; 
	_inIndex = iindex; 
	_outIndex = oindex; 
}

const Bitmask& Wire::generateBitmask() 
{
	return _bitmask|=_to->generateBitmask();
}


void Wire::connectRegister(RegisterContainer* container)
{
	assert(container);
		
	// verbinden
	_reg = container;
}

const Flit* Wire::getFlit(Node* customer) const 
{
	if (!_reg) return NULL;
	
	if(customer)
		return _reg->fetchableFlit(customer);

	return _reg->firstFlit();
}

const Packet* Wire::getPacket() const 
{
	if (!_reg) return NULL;
	
	return _reg->getPacket();
}

